<template>
  <div
    class="select"
    v-click-outside="handleClose">
    <button
      class="btn btn-select"
      :class="{'disabled' : isEmpty}"
      @click="handleDropdown">
      <span :class="{'text-xs' : small}">
        {{ filter.label || 'Aucun filtre' }}
      </span>
      <icon
        class="transition-all duration-100 ease-in-out ml-3"
        :class="{'transform rotate-180' : isOpen}"
        icon="fleche-bas"
        size="xs"/>
    </button>

    <transition
      name="fade"
      mode="out-in">
      <div
        class="select-dropdown"
        v-if="isOpen">
        <ul class="select-list">
          <li
            class="select-list--item"
            v-for="(item, index) in filter.items"
            :key="index">
            <input
              @change="handleFilter"
              class="cursor-pointer"
              type="checkbox"
              :id="item.value"
              :value="item.value"
              v-model="checked">
            <label
              :for="item.value"
              class="cursor-pointer">
              {{ item.label }}
            </label>
          </li>
        </ul>
      </div>
    </transition>
  </div>
</template>

<script>
import ClickOutside from 'vue-click-outside'

export default {
  props: {
    filter: {
      type: Object,
      default: () => ({
        value: '', // Définit quelle variable filtrer
        label: '', // Texte du bouton affiché à l'user
        items: [ // Liste des choix
          {
            value: '', // Valeur du choix pour la requête
            label: '' // Texte du choix affiché à l'user
          }
        ]
      }),
      required: true // Ne pas utiliser ce composant si filter est vide
    },

    small: {
      type: Boolean,
      default: false,
      required: false
    }
  },

  data: () => ({
    isOpen: false,
    checked: []
  }),

  computed: {
    isEmpty () {
      return this.filter.items.length === 0
    }
  },

  methods: {
    handleClose () {
      this.isOpen = false
    },

    handleDropdown () {
      this.isOpen = !this.isOpen
    },

    /**
     * On récupère le type de filtre à appliquer ainsi que l'item sélectionné,
     * puis on redirige vers une nouvelle page en y accrochant les nouvelles
     * query params (ex: department=aisne).
     */
    handleFilter () {
      const query = { ...this.$route.query }
      delete query.page
      query[this.filter.value] = this.checked.join(',')
      this.$router.replace({ query: query }).catch(() => {})
      this.$store.dispatch('drawerStatus', false)
    },

    // On regarde s'il n'y a pas des query déjà checkés dans la requête pour
    // garder le filtre en cours. Si oui => on check les checkboxes. S'il n'y a
    // aucune query correspondant, on s'assure de reset les filtres
    handleChecked () {
      if (this.$route.query[this.filter.value]) {
        this.checked = this.$route.query[this.filter.value].split(',')
      } else {
        this.checked = []
      }
    }
  },

  watch: {
    /* 'checked' () {
      this.handleFilter()
    }, */

    $route (to, from) {
      // On ferme l'onglet quand on fait une redirection (au clique sur
      // n'importe quel item puisque le choix d'un item fait une redirection +
      // append d'un query param)
      this.isOpen = false
      this.handleChecked()
    }
  },

  beforeMount () {
    this.handleChecked()
  },

  directives: {
    ClickOutside
  }
}
</script>
